#include <SPIFlash.h>
#include <SPI.h>

#define SERIAL_BAUD      115200
char input = 0;
long lastPeriod = -1;

#define FLASH_SS      8 // FLASH SS on D8

SPIFlash flash(FLASH_SS);

void setup()
{
  Serial.begin(SERIAL_BAUD);
  Serial.print("Start...");

  if (flash.initialize()) { //Инициаиализация чипа памяти и начало работы
    Serial.println("Init OK!");
  } else {
    Serial.println("Init FAIL!");
  }

  delay(1000);
}

void loop() {
  while (Serial.available()) {
    input = Serial.read();
    if (input == 's') {
      flash.chipErase(); //Предварительное очищение чипа, т.к по даташиту нельзя производить запись по тем адресам, где уже что-то записано.
      flash.sleep(); //Уход в сон
      delay(1000);
      flash.wakeup(); //Выход из сна
      delay(1000);
      
      int address = 0;
      byte ByteValue = 0xAD;
      flash.writeByte(0, ByteValue); //Запись byte
      delay(1000);
      Serial.println(flash.readByte(address++), HEX); //Чтение byte
      delay(1000);
      
      int IntValue = 0x7FD4;
      byte data[2];
      data[0] = highByte(IntValue);
      data[1] = lowByte(IntValue);
      flash.writeBytes(address, data, 2); //Запись int как массива из двух байтов. (Старший и младший разряды)
      delay(1000);
      
      byte flashData[2];
      flash.readBytes(address++, flashData, 2); //Чтение int как массива из двух байтов, word, long, unsigned long, array => аналогично
      int IntValueFlash = (flashData[0] << 8) | flashData[1] & 0xFF;
      Serial.println(IntValueFlash, HEX);

      String StringValue = "TestString";
      int len = StringValue.length();
      char char_array[len+1], char_array_new[len+1];
      strcpy(char_array, StringValue.c_str()); 

      flash.writeBytes(address, char_array, len); //Запись string как массив char`ов во флеш
      delay(1000);
      flash.readBytes(address, char_array_new, len); //Аналогичное чтение
      delay(1000);
      
      String StringValueFlash;
      for(int i = 0; i < len; i++){
        StringValueFlash += char_array_new[i];
      }
      Serial.println(StringValueFlash);
    }
    
    if (input == 'd') { //d=dump flash area
      Serial.println("Flash content:");
      int counter = 0;

      while (counter <= 256) {
        Serial.print(flash.readByte(counter++), HEX);
        Serial.print('.');
      }
    }
    
  }
}
